# -*- coding: utf-8 -*-
#       icd_radial_cl.py  2023.8.2      kita

# 関係ファイル
#   icd_module.py  my_vector.py  my_module.py  zen_han.py

# 起動方法
# py icd_radial_cl.py

# 履歴
#2023.8.22  「円形配置円CL」に2個のキリ穴と円中心指定モード追加


import clr
clr.AddReference('sxnet')
from sxnet import *
#SxSys.init(3999)
import sys
import os
import numpy as np
from numpy import linalg as LA
import my_vector as myv
import icd_module as imd
import my_module as mmd

import tkinter as tk
from tkinter import *
from tkinter import ttk # ComboBoxを使うのに必要

import threading
from time import sleep
import subprocess

# 自ファイル名取得(Path無し)
my_fn = os.path.basename(__file__)
pi= np.pi

imd.set_pen('1dot')     # 書き込み線種を一点鎖線に変更

# マウスピック範囲制定
opt = SxOptSelect()
opt.select_pos = False      # 
opt.select_ent = True

imd.set_pen('1dot') # 書き込み線種を一点鎖線にセット




#--------------------------------
# ヘルプボタン
#--------------------------------
def push_help():
    cmd = 'start Acrobat icd_rafial_cl.pdf'
    result = subprocess.call(cmd,shell=True)


def push_get_p0():  # 原点取得ボタン
    thread= threading.Thread(target=get_p0, daemon=True)
    thread.start() 

def get_p0():   # 原点取得本体
    btn_disable()   # Button無効化
    while True:
        ss= "円弧を選択し、原点を取得します"
        set_entry2(entry_msg, ss)
        (type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_SEG, ss)
        #print(type_num, seg_part)   #
        if type_num <= 0:   # Go 他コマンド Esc
            set_entry2(entry_msg,'原点の選択を終了しました')
            break            
        elif type_num== 5 or type_num== 6: # 2次元円弧 5 円 6
            set_entry2(entry_msg,'原点を取得しました')
            geom = seg_part.getGeom()
            #dvl_r= geom.radius    # 半径
            #set_entry2(entry[1], str(round(dvl_r,5)))
            p00= np.array([geom.cp.x, geom.cp.y])
            set_entry2(entry[1],(str(round(p00[0],4))+', '+ str(round(p00[1],4))))
            break 
        else:
            warning('円弧以外が選択されました')
            #break
            continue
    btn_normal()



def push_P0circle(): # P0を中心とする円弧上に配置された円CL
    thread= threading.Thread(target=P0_circle, daemon=True)
    thread.start() 
    
    
def P0_circle(): # P0中心円弧配置  
    btn_disable()   # Button無効化
    (color_no, p00, lh)= get_ent()
    # 大円弧選択
    ss= "P0を中心とする円弧を選択"
    set_entry2(entry_msg, ss)
    (type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_SEG, ss)
    if type_num <= 0:   # Go　他のコマンド　Esc
        set_entry2(entry_msg,'中心線の作図を終了しました')
        btn_normal()      
        return
    elif type_num== 5 or type_num== 6: # 2次元円弧 5 円 6
        set_entry2(entry_msg,'原点を取得しました')
        geom = seg_part.getGeom()
        p00= np.array([geom.cp.x, geom.cp.y])
        set_entry2(entry[1],(str(round(p00[0],3))+', '+ str(round(p00[1],3))))
    else:
        warning('円弧以外が選択されました')
        btn_normal()      
        return
         
        
    ss= 'キリ、タップを選択してください'
    set_entry2(entry_msg, ss)
    #(type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_MULTI, ss1)
    ent_list= SxSys.getEntList(SxSys.ENTMODE_MULTI) # マウスドラッグ
                                                # Esc keyでコマンドキャンセル
    if ent_list== None: # Esc で抜けた場合
        set_entry2(entry_msg,'円形配置円を終了しました')
        btn_normal()
        return


    if len(ent_list) == 1:
        type_num= ent_list[0].getInf().type
        if type_num== 5 or type_num== 6: # 2次元円弧 5 円 6
            one_circle_skz(ent_list[0], None)    # 単円CL作図
            btn_normal()
            return
        elif type_num== 201: # 実像部品
            seg_list= ent_list[0].getEntList()
            for seg in seg_list:
                type_num= seg.getInf().type
                #print(type_num) #
                if type_num== 2: # 直線
                    inf= seg.getLineAttribute()
                    # 中心線削除
                    if inf[1]== 3:   # 中心線
                        seg.delete()
                if type_num== 6: # 円
                    one_circle_skz(seg, None)
                
        
    
    # 複数個のキリ、タップ
    cp_list= []; r_list= []
    for ent in ent_list:
        type_num= ent.getInf().type
        if type_num== 6: # 2次元円 6
            #print('2次元icd_radial_cl_.py円 6')  ####
            geom= ent.getGeom()     # Geometry情報取得
            cp_list.append(np.array([geom.cp.x, geom.cp.y]))
            r_list.append(geom.radius)
            continue    
        
        elif type_num== 201: # 実像部品　キリ穴、タップ等
            seg_list= ent.getEntList()
            for seg in seg_list:
                type_num= seg.getInf().type
                if type_num== 2: # 直線
                    inf= seg.getLineAttribute()
                    # 中心線削除
                    if inf[1]== 3:   # 中心線
                        seg.delete()
                if type_num== 6: # 円
                    geom= seg.getGeom()     # Geometry情報取得
                    cp_list.append(np.array([geom.cp.x, geom.cp.y]))            
                    r_list.append(geom.radius)
        else:
            #warning('円,実像部品以外が選択されました')
            #break
            continue
    #print('cp_list長さ   %d' % len(cp_list))
    if len(cp_list) != 0:
        r_max= max(r_list)
        circle_sort_skz(cp_list, r_max, mode=1)  # P00中心円弧上配置

    btn_normal()


def push_1circle(): # P0を中心とする円弧上に配置された円CL
    thread= threading.Thread(target=one_circle, daemon=True)
    thread.start() 


def one_circle():   
    btn_disable()   # Button無効化
    # P00取得のための円弧選択
    ss= "P0を中心とする円弧を選択"
    set_entry2(entry_msg, ss)
    (type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_SEG, ss)
    if type_num <= 0:   # Go　他のコマンド　Esc
        set_entry2(entry_msg,'中心線の作図を終了しました')
        btn_normal()      
        return
    elif type_num== 5 or type_num== 6: # 2次元円弧 5 円 6
        set_entry2(entry_msg,'原点を取得しました')
        geom = seg_part.getGeom()
        p00= np.array([geom.cp.x, geom.cp.y])
        set_entry2(entry[1],(str(round(p00[0],3))+', '+ str(round(p00[1],3))))
    else:
        warning('円弧以外が選択されました')
        btn_normal()      
        return

    while True:
        #ss= 'P0中心円弧上に配置された円のCL'
        ss= '円、円弧を選択してください'
        set_entry2(entry_msg, ss)
        (type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_MULTI, ss)
        #(type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_SEG, ss)
        #print(type_num, seg_part)   #

        if type_num <= 0:   # Go 他のコマンド
            set_entry2(entry_msg,'単円中心線の作図を終了しました')
            break

        elif type_num== 5 or type_num== 6: # 2次元円弧 5 円 6
            one_circle_skz(seg_part, None)
            continue    
            #break
        
        elif type_num== 201: # 実像部品
            seg_list= seg_part.getEntList()
            for seg in seg_list:
                type_num= seg.getInf().type
                if type_num== 2: # 直線
                    inf= seg.getLineAttribute()
                    # 中心線削除
                    if inf[1]== 3:   # 中心線
                        seg.delete()
                if type_num== 6: # 円
                    one_circle_skz(seg, None)
                
        else:
            warning('円弧以外が選択されました')
            #break
            continue

    btn_normal()



def push_1circle2():    #単円CL（基準線）
    thread= threading.Thread(target=one_circle2, daemon=True)
    thread.start() 
    
def one_circle2():  #単円基準線中心線
    #(color_no, p00, lh, nx, ny)= get_ent()
    btn_disable()   # Button無効化
    flg= 0
    while True:
        ss= '基準線と並行な単円中心線を作図します'
        set_entry2(entry_msg, ss)
        if flg== 0:
            ss1= '基準線を選択してください'
        else:
            ss1= '円弧を選択してください'

        (type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_MULTI, ss1)
        #(type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_SEG, ss)
        print(type_num, seg_part)   #

        if type_num <= 0:   # Go 他のコマンド Esc
            set_entry2(entry_msg,'単円中心線の作図を終了しました')
            break

        elif flg== 0 and type_num== 2 : # 基準線
            seg_l= seg_part
            flg= 1
            continue
    
        elif flg== 1 and (type_num== 5 or type_num== 6): # 2次元円弧 5 円 6
            one_circle_skz(seg_part, seg_l)
            continue    
            #break
        
        elif flg== 1 and type_num== 201: # 実像部品
            seg_list= seg_part.getEntList()
            for seg in seg_list:
                type_num= seg.getInf().type
                #print(type_num) #
                if type_num== 2: # 直線
                    inf= seg.getLineAttribute()
                    # 中心線削除
                    if inf[1]== 3:   # 中心線
                        seg.delete()
                if type_num== 6: # 円
                    one_circle_skz(seg, seg_l)
                
        else:
            warning('円弧以外が選択されました')
            #break
            continue

    btn_normal()


def one_circle_skz(seg, seg_l):    # 単円CL作図本体
    #print('単円CL作図します')   #
    (color_no, p00, lh)= get_ent()
    SxSys.setPenColor(color_no)
    
    geom = seg.getGeom()
    r= geom.radius    # 半径
    p0= np.array([geom.cp.x, geom.cp.y])
    vy= np.array([p0[0]-p00[0], p0[1]-p00[1]])
    if seg_l== None:
        vy_= vy/LA.norm(vy)
    else:
        geom_l = seg_l.getGeom()
        vy_= np.array([geom_l.vec.x, geom_l.vec.y])
        
    vx_= myv.rotate2(vy_,pi/2)  # vy_の法線ベクトル
    tmp0= p00+ vy- (r+lh)*vy_
    tmp1= 2*(r+lh)*vy_
    seg1= imd.p2p_line(tmp0,tmp1)
    tmp0= p00+ vy- (r+lh)*vx_
    tmp1= 2*(r+lh)*vx_
    seg2= imd.p2p_line(tmp0,tmp1)

# ----------- one_circle End -------------

def push_en_naga_ana(): # 円長穴ボタン
    thread= threading.Thread(target=en_naga_ana, daemon=True)
    thread.start() 
    
def en_naga_ana(): # 円長穴ボタン
    #(color_no, p00, lh)= get_ent()
    #SxSys.setPenColor(color_no)
    btn_disable()   # Button無効化
    cnt= 0
    seg_list= []; cp_list= []; r_list= []
    nn= int(cb_naga.get())
    #print(nn)   #
    while True:
        ss='1個目の長穴円弧を選択してください'
        set_entry2(entry_msg, ss)
        (type_num1, seg1) = imd.get_mouse_pick2(SxSys.ENTMODE_MULTI,ss)     # type num, Segmentをマウスピックで取得
        #(type_num1, seg1) = imd.get_mouse_pick2(SxSys.ENTMODE_SEG,ss)     # type num, Segmentをマウスピックで取得
        #print(type_num1, seg1)
        if type_num1 <= 0 :     # Go 他のコマンド Esc
            set_entry2(entry_msg,'長穴中心線の作図を終了しました')
            break        # loop終了

        elif type_num1 == 5:  # 円弧
            geom= seg1.getGeom()     # Geometry情報取得
            th= geom.eang
            p0= np.array([geom.cp.x, geom.cp.y])    # 円弧中心
            # 2本目の円弧
            ss='2個目の長穴円弧を選択してください'
            set_entry2(entry_msg, ss)
            (type_num2, seg2) = imd.get_mouse_pick2(SxSys.ENTMODE_SEG,ss)# type num, Segmentをマウスピックで取得 2
            geom= seg2.getGeom()     # Geometry情報取得
            p2= np.array([geom.cp.x, geom.cp.y])
            if not (p0== p2).all():
                warning(' 同心円ではありません')
                continue

            en_naga_ana_skz(seg1, seg2, nn)
            #seg_list+= en_naga_ana_skz(seg1, seg2, nn)
            break
        elif type_num1 == 6:  # 円
            geom= seg1.getGeom()     # Geometry情報取得
            en_ana_skz(seg1, nn)
            break
        elif type_num1== 201: # 実像部品
            seg_list= seg1.getEntList()
            for seg in seg_list:
                type_num= seg.getInf().type
                #print(type_num) #
                if type_num== 2: # 直線
                    inf= seg.getLineAttribute()
                    # 中心線削除
                    if inf[1]== 3:   # 中心線
                        seg.delete()
                elif type_num== 6: # 円
                    en_ana_skz(seg, nn)
                    #one_circle_skz(seg, seg_l)
            break
        

        else:
            warning('円弧以外が選択されました')
            #break
            continue

    btn_normal()


def en_ana_skz(seg,nn):    # 円穴連続配列
    (color_no, p00, lh)= get_ent()
    SxSys.setPenColor(color_no)

    pos0= SxPos(p00[0], p00[1], 0.0)
    geom = seg.getGeom()
    r= geom.radius    # 半径
    p0= np.array([geom.cp.x, geom.cp.y])
    rc0= LA.norm(p0-p00)    #大円半径
    vy= np.array([p0[0]-p00[0], p0[1]-p00[1]])
    vy_= vy/LA.norm(vy)
        
    #seg_list= []
    #vx_= myv.rotate2(vy_,pi/2)  # vy_の法線ベクトル
    tmp0= p00+ vy- (r+lh)*vy_
    tmp1= 2*(r+lh)*vy_
    #seg_list.append(imd.p2p_line(tmp0,tmp1))
    #tmp0= vy- (r+lh)*vx_
    #tmp1= 2*(r+lh)*vx_
    #seg_list.append(imd.p2p_line(tmp0,tmp1))
    seg= imd.p2p_line(tmp0,tmp1)
    if nn!= 1:
        d_th= float(round(360.0/nn))
        for i in range(nn-1):
            th_ang= (i+1)*d_th
            print(type(th_ang), th_ang)
            seg.copy2DRotate(pos0, th_ang, True, True, True)
            #seg_list.append(SxEnt.copy2DRotate(seg_list2, pos0, th_ang, True, True, True))
            #for seg in seg_list:
            #    seg.copy2DRotate(pos0, th_ang, True, True, True)
        
    # 大円
    SxEntSeg.createCircle2D(pos0, 2.0*rc0)


# 円長穴中心線作図本体
def en_naga_ana_skz(seg1, seg2, nn):
    (color_no, p00, lh)= get_ent()
    SxSys.setPenColor(color_no)
    # 1本目の円弧 
    geom1= seg1.getGeom()     # Geometry情報取得
    p0= np.array([geom1.cp.x, geom1.cp.y])    # 円弧中心
    pos0= SxPos(p0[0], p0[1], 0.0)
    r1= geom1.radius
    ths= geom1.sang; th= geom1.eang
    #print('中心座標x= %.3f y= %.3f 半径= %.3f' % (p0[0], p0[1], r1))
    #print('始角 θs= %.3f 終角 θe= %.3f' % (geom.sang, geom.eang)) #終角は相対値
    # 2本目の円弧 
    #(type_num2,seg2) = get_mouse_pick2(SxSys.ENTMODE_SEG)# type num, Segmentをマウスピックで取得 2
    geom2= seg2.getGeom()     # Geometry情報取得
    p2= np.array([geom2.cp.x, geom2.cp.y])    # 円弧2中心
    r2= geom2.radius
    v0_= np.array([1.0, 0.0])

    rc0= (r1+r2)/2; rc1= abs(r2-r1)/2
    vs= rc0* myv.rotate2(v0_, np.deg2rad(ths))
    ve= rc0* myv.rotate2(v0_, np.deg2rad(ths+th))
    vse= rc0* myv.rotate2(v0_, np.deg2rad(ths+th/2))
    vs_= vs/LA.norm(vs)
    ve_= ve/LA.norm(ve)
    vse_= vse/LA.norm(vse)

    seg_list= []
    tmp0= p0+ (rc0-lh-rc1)* vs_
    tmp1= 2*(lh+rc1)* vs_
    seg= imd.p2p_line(tmp0, tmp1)   # 1本目のCL
    seg_list.append(seg)

    tmp0= p0+ (rc0-lh-rc1)* ve_
    tmp1= 2*(lh+rc1)* ve_
    seg= imd.p2p_line(tmp0, tmp1)   # 2本目のCL
    seg_list.append(seg)
    
    tmp0= p0+ (rc0-2*lh-rc1)* vse_
    tmp1= 2*(2*lh+rc1)* vse_
    seg= imd.p2p_line(tmp0, tmp1)   # 3本目のCL
    seg_list.append(seg)
    
    #seg_list.append(seg.copy2DRotate(pos0, th, True, True, True))
    #seg_list2= seg_list
    #print(len(seg_list), type(seg_list))
    if nn!= 1:
        d_th= float(round(360.0/nn))
        for i in range(nn-1):
            th_ang= (i+1)*d_th
            #print(type(th_ang), th_ang)
            SxEnt.copy2DRotate(seg_list, pos0, th_ang, True, True, True)
            #seg_list.append(SxEnt.copy2DRotate(seg_list2, pos0, th_ang, True, True, True))
            #for seg in seg_list:
            #    seg.copy2DRotate(pos0, th_ang, True, True, True)
        
    # 大円
    seg_list.append(SxEntSeg.createCircle2D(pos0, 2.0*rc0))

    return seg_list
# ----------- en_naga_ana End -------------




#------------------------------------------------------------------- 
#   円形配置円CLボタン  2023.8.22 2個のキリ穴と円中心指定モードを追加
#------------------------------------------------------------------- 
def push_circle_sort(): # 円形配置CLボタン
    thread= threading.Thread(target=circle_sort, daemon=True)
    thread.start()

def circle_sort():  #円形配置円CL 
    btn_disable()   # Button無効化    
    ss='円、タップ選択（Esc Keyでキャンセル）'
    set_entry2(entry_msg, ss)
    ent_list= SxSys.getEntList(SxSys.ENTMODE_MULTI) # マウスドラッグ
                                                # Esc keyでコマンドキャンセル
    # print('ent_list長さ   %d ' % len(ent_list))
    if ent_list== None: # Esc で抜けた場合
        set_entry2(entry_msg,'円形配置円を終了しました')
        btn_normal()
        return

    cp_list= []; r_list= []
    for ent in ent_list:
        type_num= ent.getInf().type
        if type_num== 6: # 2次元円 6
            #print('2次元icd_radial_cl_.py円 6')  ####
            geom= ent.getGeom()     # Geometry情報取得
            cp_list.append(np.array([geom.cp.x, geom.cp.y]))
            r_list.append(geom.radius)
            continue    
        
        elif type_num== 201: # 実像部品　キリ穴、タップ等
            seg_list= ent.getEntList()
            for seg in seg_list:
                type_num= seg.getInf().type
                if type_num== 2: # 直線
                    inf= seg.getLineAttribute()
                    # 中心線削除
                    if inf[1]== 3:   # 中心線
                        seg.delete()
                if type_num== 6: # 円
                    geom= seg.getGeom()     # Geometry情報取得
                    cp_list.append(np.array([geom.cp.x, geom.cp.y]))            
                    r_list.append(geom.radius)
        else:
            #warning('円,実像部品以外が選択されました')
            #break
            continue
    #print('cp_list長さ   %d' % len(cp_list))
    if len(cp_list) != 0:
        r_max= max(r_list)
        circle_sort_skz(cp_list, r_max)

    btn_normal()
 

def circle_sort_skz(cp_list, r, mode= 0):  #円形配置円CL P0中心円弧配置を追加
                            # mode== 0 自動円弧中心 1:P00円弧中心
    (color_no, p00, lh)= get_ent()
    SxSys.setPenColor(color_no)

    # P0中心円弧配置キリ、タップ
    if mode== 1:         
        pos0= SxPos(p00[0], p00[1], 0.0)
        cp0= cp_list[0]
        rc0= LA.norm(p00-cp0) 

        for cp in cp_list:
            vy= np.array([cp[0]-p00[0], cp[1]-p00[1]])
            vy_= vy/LA.norm(vy)
            tmp0= p00+ vy- (r+lh)*vy_
            tmp1= 2*(r+lh)*vy_
            imd.p2p_line(tmp0,tmp1)

        # 大円
        SxEntSeg.createCircle2D(pos0, 2.0*rc0)
        return 




    # P00指定以外のキリ、タップ配置
    l_pls= r+ lh
    nn= len(cp_list)
    if nn== 2:    # ２円
        vx= cp_list[1]- cp_list[0]
        vx_= vx/LA.norm(vx)
        tmp0= cp_list[0]- l_pls*vx_
        tmp1= vx+ 2*l_pls*vx_
        imd.p2p_line(tmp0, tmp1)
        for cp in cp_list:
            vy_= myv.rotate2(vx_, pi/2)
            tmp0= cp- l_pls*vy_
            tmp1= 2*l_pls*vy_
            imd.p2p_line(tmp0, tmp1)

    elif nn > 2:   #３以上円
        #p12= no.array(([cp_list[1][0]- cp_list[0][0])/2.0, (cp_list[1][1]- cp_list[0][1])/2.0]) 
        #p23= no.array(([cp_list[2][0]- cp_list[1][0])/2.0, (cp_list[2][1]- cp_list[1][1])/2.0])
        cp0= cp_list[0]
        cp1= cp_list[1]
        cp2= cp_list[2]
        v01= cp1- cp0
        v12= cp2- cp1
        
        A= (cp1+v12/2)- (cp0+v01/2)
        Bm= myv.rotate2(v12, -pi/2)   
        Bp= myv.rotate2(v12, +pi/2)   
        Cm= myv.rotate2(v01, -pi/2)   
        Cp= myv.rotate2(v01, +pi/2)

        if LA.norm(cp0- (cp1+v12/2+Bm)) <= LA.norm(cp0- (cp1+v12/2+Bp)):
            B= Bm
        else:
            B= Bp
        if LA.norm(cp2- (cp0+v01/2+Cm)) <= LA.norm(cp0- (cp0+v01/2+Cp)):
            C= Cm
        else:
            C= Cp

        #imd.p2p_line(cp0+v01/2, A, '赤')
        #imd.p2p_line(cp1+v12/2, B, '緑')
        #imd.p2p_line(cp0+v01/2, C, '空')
        
        (n, v)= myv.case2(A, B, C)
        #print(v[2][0])
        C= v[2][0]
        cp00= cp0+ v01/2+C    # 大円中心
        pos0= SxPos(cp00[0], cp00[1], 0.0)
        rc0= LA.norm(cp00-cp0) 
        #print('rc0= %f' % rc0)  ####
        # 大円
        try:
            SxEntSeg.createCircle2D(pos0, 2.0*rc0)
        except:
            warning('穴の配置が円弧状ではないようです')
            return
        for cp in cp_list:
            vy= np.array([cp[0]-cp00[0], cp[1]-cp00[1]])
            vy_= vy/LA.norm(vy)
            tmp0= cp00+ vy- (r+lh)*vy_
            tmp1= 2*(r+lh)*vy_
            imd.p2p_line(tmp0,tmp1)

    else:
        set_entry2(entry_msg,'円形配置円を終了しました')
        return
        #imd.p2p_line(p00, cp00,'赤')

        #x_list= cp_exist_bak(tmpy, cp0, cpx)
        #x_list= cp_exist(tmpy, cp0, cpx)
        #y_list= cp_exist_bak(tmpx, cp0, cpy)
        #y_list= cp_exist(tmpx, cp0, cpy)



#------------------------------------------------------------------- 
#   四角配置円CLボタン
#------------------------------------------------------------------- 
def push_sqare_sort(): # 四角配置円CLボタン
    thread= threading.Thread(target=sqare_sort, daemon=True)
    thread.start()


def sqare_sort():  #四角配置円CL 
    btn_disable()   # Button無効化    
    ss='円、タップ選択（Esc Keyでキャンセル）'
    set_entry2(entry_msg, ss)
    ent_list= SxSys.getEntList(SxSys.ENTMODE_MULTI) # マウスドラッグ
    if ent_list== None: # Esc で抜けた場合
        set_entry2(entry_msg,'四角配置円を終了しました')
        btn_normal()
        return

    cp_list= []; r_list= []
    for ent in ent_list:
        type_num= ent.getInf().type
        if type_num== 5 or type_num== 6: # 2次元円弧 5 円 6
            geom= ent.getGeom()     # Geometry情報取得
            cp_list.append(np.array([geom.cp.x, geom.cp.y]))
            r_list.append(geom.radius)
            continue    
        
        elif type_num== 201: # 実像部品
            seg_list= ent.getEntList()
            for seg in seg_list:
                type_num= seg.getInf().type
                if type_num== 2: # 直線
                    inf= seg.getLineAttribute()
                    # 中心線削除
                    if inf[1]== 3:   # 中心線
                        seg.delete()
                if type_num== 6: # 円
                    geom= seg.getGeom()     # Geometry情報取得
                    cp_list.append(np.array([geom.cp.x, geom.cp.y]))            
                    r_list.append(geom.radius)
        else:
            #warning('円,実像部品以外が選択されました')
            #break
            continue

    if len(cp_list) != 0:
        r_max= max(r_list)
        sqare_sort_skz(cp_list, r_max)

    btn_normal()



def sqare_sort_skz(cp_list, r):  #四角配置円CL
    (color_no, p00, lh)= get_ent()
    SxSys.setPenColor(color_no)

    l_pls= r+ lh
    if len(cp_list)== 2:    # ２円
        vx= cp_list[1]- cp_list[0]
        vx_= vx/LA.norm(vx)
        tmp0= cp_list[0]- l_pls*vx_
        tmp1= vx+ 2*l_pls*vx_
        imd.p2p_line(tmp0, tmp1)
        for cp in cp_list:
            vy_= myv.rotate2(vx_, pi/2)
            tmp0= cp- l_pls*vy_
            tmp1= 2*l_pls*vy_
            imd.p2p_line(tmp0, tmp1)

    else:   #３以上円
        tmpx= sorted(cp_list, key=lambda x: x[0])
        tmpy= sorted(cp_list, key=lambda x: x[1])
        tmpxy= sorted(tmpx, key=lambda x: x[1])
        tmpyx= sorted(tmpy, key=lambda x: x[0])

        if (tmpxy[0]== tmpyx[0]).all():   # Vectorが等しい
            #print(' xy 軸と直行!!')      # すなわち、円弧配列が xy 軸と直行している
            cp0= tmpxy[0]
            cpx= np.array([tmpxy[-1][0], tmpxy[0][1]])   #->
            cpy= np.array([tmpxy[0][0], tmpxy[-1][1]])   #|^
        else:   #  円弧配列が xy 軸に対して傾いている
            cp0= tmpx[0]
            cpx= tmpy[0]
            cpy= tmpy[-1]
       
        vx=  cpx-cp0; vy= cpy-cp0

        #imd.p2p_line(cp0, vx, '赤')
        #imd.p2p_line(cp0, vy, '白')  ####

        vx_= vx/LA.norm(vx)
        vy_= vy/LA.norm(vy)
    
        v_lx= (LA.norm(vx)+2*l_pls)*vx_
        v_ly= (LA.norm(vy)+2*l_pls)*vy_
        
        #x_list= cp_exist_bak(tmpy, cp0, cpx)
        x_list= cp_exist(tmpy, cp0, cpx)
        #y_list= cp_exist_bak(tmpx, cp0, cpy)
        y_list= cp_exist(tmpx, cp0, cpy)

        for cp in x_list:
            tmp= cp- l_pls*vy_
            imd.p2p_line(tmp, v_ly)
        for cp in y_list:
            tmp= cp- l_pls*vx_
            imd.p2p_line(tmp, v_lx)


# ----------- sqare_sort End -------------




def push_cross2pls():   # 断面２等分中心線　ちょっと長い
    thread= threading.Thread(target=cross2pls, daemon=True)
    thread.start()    

def cross2pls():   # 断面２等分中心線本体　ちょっと長い
    btn_disable()   # Button無効化
    (color_no, p00, lh)= get_ent()
    SxSys.setPenColor(color_no)
    while True:
        ss= "一本目の直線選択"
        set_entry2(entry_msg, ss)
        #(type_num, seg_part)= imd.get_mouse_pick2(SxSys.ENTMODE_MULTI, ss)
        (type_num1, seg1)= imd.get_mouse_pick2(SxSys.ENTMODE_SEG, ss)
        #print('No1:   ', type_num1, seg1)   #

        if type_num1 <= 0:   # Go　他のコマンド　Esc
            set_entry2(entry_msg,'中心線の作図を終了しました')
            break            
        elif type_num1== 2 : # 直線
            geom = seg1.getGeom()
            ps1= np.array([geom.sp.x, geom.sp.y])    # 始点
            pe1= ps1+ geom.leng* np.array([geom.vec.x, geom.vec.y])    # 終点
            v1_= np.array([geom.vec.x, geom.vec.y]) # 単位Vector 
            # ２本目
            ss= "二本目の直線選択"
            (type_num2, seg2)= imd.get_mouse_pick2(SxSys.ENTMODE_SEG, ss)
            geom = seg2.getGeom()
            ps2= np.array([geom.sp.x, geom.sp.y])    # 始点
            pe2= ps2+ geom.leng* np.array([geom.vec.x, geom.vec.y])    # 終点
            v2_= np.array([geom.vec.x, geom.vec.y])  # 単位Vector
            if not np.array_equal(v1_, v2_):  # 反対向き
                ps2, pe2= pe2, ps2  # Vectort入れ替え
            pc = np.array([(ps1[0]+ps2[0])/2, (ps1[1]+ps2[1])/2])
            tmp1= pc- lh*v1_
            tmp2= (geom.leng+2*lh)* v1_
            seg3= imd.p2p_line(tmp1,tmp2)
            
            continue
            #break
        
        else:
            warning('直線以外が選択されました')
            #break
            continue
    btn_normal()
    
# ----------- cross2pls  End -------------
    




#-----------------------------------------
#   関数一般
#-----------------------------------------
def cp_exist(cp_list, ps, pe, gosa=0.0001):
    xs= ps[0]; ys= ps[1]
    xe= pe[0]; ye= pe[1]
    #print('\n   xs= %.3f  ys= %.3f  xe= %.3f  ye= %.3f' % (xs, ys, xe, ye))  #
    if xs== xe: # y軸上を検索
        a=0; b=0; type_xy= 0
    elif ys== ye: # x軸上を検索
        a=0; b=0; type_xy= 1
    else: # x軸でも　y軸でもない
        a= (ys-ye)/ (xs-xe)
        b= ys- a*xs
        type_xy= 2

    exist_list0= []
    #y_list= []; x_list= []
    for cp in cp_list:
        if type_xy== 0: # y軸上を検索　
            if abs(xs-cp[0]) < gosa:
                exist_list0.append(cp)

        elif type_xy== 1: # x軸上を検索  
            if abs(ys-cp[1]) < gosa:
                exist_list0.append(cp)
        else:
            x= cp[0]
            y= a*x+ b
            if abs(y-cp[1]) < gosa:
                exist_list0.append(cp)

        
    exist_list1= sorted(exist_list0, key=lambda x: x[0])
    exist_list= sorted(exist_list1, key=lambda x: x[1])
    
    #for cp in exist_list:   ####
    #    print('%.1f  %.1f' % (cp[0], cp[1]))

    return exist_list


def cp_exist_bak(cp_list, ps, pe, gosa=0.0001): # 傾いた円列にはOK
    xs= ps[0]; ys= ps[1]
    xe= pe[0]; ye= pe[1]
    #print('\n   xs= %.3f  ys= %.3f  xe= %.3f  ye= %.3f' % (xs, ys, xe, ye))  #
    if xs-xe == 0:
        a= 0
    else:
        a= (ys-ye)/ (xs-xe)
        b= ys- a*xs

    exist_list0= []
    for cp in cp_list:
        y= a*cp[0]+ b
        if abs(y-cp[1]) < gosa:
            imd.p2p_line(np.array([0.0, 0.0]), cp, '赤')    ####
            exist_list0.append(cp)
            #print(exist_list0[-1])  #
    
    exist_list= sorted(exist_list0, key=lambda x: x[0])

    return exist_list


def get_ent():  # Entry(原点、はみ出し長)
    arr= entry[1].get().split(',')
    p00= np.array([float(arr[0]),float(arr[1])])
    lh= float(entry[0].get())   # はみ出し長
    #arr= entry[2].get().split(',')
    #nx= int(arr[0]); ny= int(arr[1])
    idx= cb_color.current()  # Indexを取得
    color_no=color_no_list[idx] 
    return (color_no, p00, lh)    # 原点、はみ出し長さ
     
def del_cl(rpart_list):   #実像部品内の中心線を削除
    for seg in rpart_list:  # 実像部品内の要素を順次呼び出す
        type_num= seg.getInf().type
        inf= seg.getLineAttribute() # inf[0]:線幅 inf[1]:線種 inf[2]:線色
        if type_num== 2 and inf[1]== 3: # 一点鎖線の直線
            seg.delete()    # SxEntの共有メソッド、削除


def message(ss):    # Entry_msgにメッセージ表示
    set_entry2(entry_msg,ss)

def warning(ss):    # Entry_msgに警告文表示
    set_entry2(entry_msg,ss)
    print('\007')
    entry_msg.configure(bg= 'orange')
    sleep(2)
    entry_msg.configure(bg= e_bcol)


def btn_disable():  # ボタン無効化
    for i in range(len(btn)):
        btn[i]['state'] = 'disabled'


def btn_normal():   # ボタン有効化
    for i in range(len(btn)):
        btn[i]['state'] = 'normal'
        #btn['state'] = 'normal
    ss= 'ボタンを選択して下さい'    
    set_entry2(entry_msg, ss)

def set_entry2(ent, ss): # Entryに文字列を挿入
    ent.delete(0,tk.END)
    ent.insert(0,ss)

#終了時の処理
def on_closing():       
    SxSys.setLayer(1)   #書き込みレヤーの設定
    #save_data(save_fn)
    print('\n   %s を終了しました\n' % my_fn)
    root.destroy()

def cb_color_selected(event):
    idx= cb_color.current()  # Indexを取得
    label_color.configure(bg= color_ss[idx])    




#************************************
# ボタン等の部品配置
#************************************
nl = 10; dy= 28
root = tk.Tk()
root.attributes("-topmost", True)    # 常に前面に表示
root.configure(bg='RoyalBlue4')
root.title(my_fn)  #タイトル
#root.title(os.path.basename(__file__))  #タイトル
#root.title('icd_radial_cl.py')   #タイトル
save_fn_geom = my_fn.replace('.py', '.ini')
ss_geom = mmd.read_geometry(save_fn_geom)
if ss_geom == None:
    ss_geom = '220x%d+1000+0' % (nl*dy)

root.geometry(ss_geom)

x0= 10; y0= 2; dx= 100
px= 2; py= 2
ie=0


btn_bcol = 'grey21'     #ボタン背景色
btn_tcol = 'white'      #ボタン文字色
label_bcol = 'khaki3'   #ラベル背景色
label_tcol = 'black'   #ラベル文字色
e_bcol = 'khaki4'



btn= []; entry=[]
iy= 0
# 線色
color_txt= ['白','空','赤','緑','橙','灰','桃','紫']
color_no_list=  [1,     12,   2,   3,   9,   8,   6,  13]
color_ss=  ['snow','sky blue','red','green2','orange','ivory3','pink','purple']
v_color = tk.StringVar()
cb_color = ttk.Combobox(root, width=3,textvariable = v_color) #, style="BW.TLabel")
cb_color.bind('<<ComboboxSelected>>', cb_color_selected)
cb_color['values']= color_txt
#cb_color['values']=('白','空','赤','緑','橙','灰','桃','紫')
ic= 1
cb_color.current(ic)
cb_color.place(x=x0,y=y0+iy*dy)
label_color= tk.Label(root, text='線色',bg=color_ss[ic], fg=label_tcol)
label_color.place(x= x0+45, y= y0+iy*dy)

# はみ出し長さ
entry.append(tk.Entry(root, width=5,justify="right",bg=e_bcol))
entry[-1].place(x= x0+90, y= y0+iy*dy); ie+= 1   
entry[-1].insert(0,'10')
label= tk.Label(root, text='はみ出長',bg=label_bcol,fg=label_tcol)
label.place(x= x0+135, y= y0+iy*dy); iy+=1

# Frame1の作成------------------------------------------------------------------------------------
frame1 = tk.LabelFrame(root, text='P0中心円弧配置', padx=px, pady=py,bg="RoyalBlue3",fg=btn_tcol) 
frame1.place(x=x0,y=y0+25)

# 原点
entry.append(tk.Entry(frame1, width=15,justify="right",bg=e_bcol))
entry[-1].grid(column=0,row=0, padx=px, pady=py); ie+= 1   
#entry[-1].place(x= x0+10, y= y0+iy*dy); ie+= 1   
entry[-1].insert(0,'0.0, 0.0')
label= tk.Label(frame1,text= 'P0座標', bg=label_bcol)
label.grid(column=1, row=0, padx=px, pady=py)
#btn.append(tk.Button(frame1,text= 'Get_P0',command = push_get_p0,bg=btn_bcol,fg=btn_tcol))
#btn[-1].grid(column=1, row=0, padx=px, pady=py)

# P0中心円弧上に配置された円CL
btn.append(tk.Button(frame1,text= '円弧上配置CL',command = push_P0circle,bg=btn_bcol,fg=btn_tcol))
btn[-1].grid(column=0, row=1, padx=px, pady=py)

# 単円CL#(P0向十字)
btn.append(tk.Button(frame1,text= '単円十字CL',command = push_1circle,bg=btn_bcol,fg=btn_tcol))
btn[-1].grid(column=1, row=1, padx=px, pady=py)
# Frame1------------------------------------------------------------------------------------

iy+=3
# 円長穴
v_naga = tk.StringVar()
cb_naga = ttk.Combobox(root, width=3,textvariable = v_naga) #, style="BW.TLabel")
#cb_naga.bind('<<ComboboxSelected>>', cb_naga_selected)
cb_naga['values']=('1','2','3','4','5','6','7','8')
cb_naga.current('5')
cb_naga.place(x=x0+25,y=y0+iy*dy)

btn.append(tk.Button(root,text= '等分割円長穴CL',command = push_en_naga_ana,bg=btn_bcol,fg=btn_tcol))
btn[-1].place(x= x0+dx, y= y0+iy*dy); iy+=1

# 円形配置CL
btn.append(tk.Button(root,text= '円形配置円CL',command = push_circle_sort,bg='orange',fg='black'))
btn[-1].place(x= x0, y= y0+iy*dy)

# 四角配置CL
btn.append(tk.Button(root,text= '４角配置円CL',command = push_sqare_sort,bg=btn_bcol,fg=btn_tcol))
btn[-1].place(x= x0+dx, y= y0+iy*dy) ; iy+=1
#btn[-1]['state']= tk.DISABLED

# 単円CL(基準線)
btn.append(tk.Button(root,text= '単円CL(基準線)',command = push_1circle2,bg=btn_bcol,fg=btn_tcol))
#btn[-1].grid(column=1, row=1, padx=px, pady=py)
btn[-1].place(x= x0, y= y0+iy*dy)
#btn[-1]['state']= tk.DISABLED

# 断面中心線　ピックした2本の線より長い線を引いてくれる
btn.append(tk.Button(root,text= '断面2等分CL',command = push_cross2pls,bg=btn_bcol,fg=btn_tcol))
btn[-1].place(x= x0+dx, y= y0+iy*dy); iy+=1


# メッセージ用 Entry
entry_msg=(tk.Entry(root, width=30,justify="right",bg=e_bcol)) 
entry_msg.place(x= x0, y= iy*dy)


# 起動時の処理
ss= 'ボタンを選択して下さい'    
set_entry2(entry_msg, ss)


# 終了時の処理の定番
def on_closing():       
    SxSys.setLayer(1)   #書き込みレヤーの設定
    #save_data(save_fn)
    print('\n   %s を終了しました\n' % my_fn)
    ss_geom = root.geometry() 
    mmd.save_geometry(save_fn_geom, ss_geom)

    root.destroy()


root.protocol("WM_DELETE_WINDOW", on_closing)   #終了時処理
root.mainloop()

